scala.reflect.macros

# Typers

#### trait Typers extends AnyRef

EXPERIMENTAL

A slice of the Scala macros context that partially exposes the type checker to macro writers.

Self Type
  Context
Source
  Typers.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Context
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Typers
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def inferImplicitValue(pt: Context.Type, silent: Boolean = true, withMacrosDisabled: Boolean = false, pos: Context.Position = enclosingPosition): Context.Tree

   Infers an implicit value of the expected type `pt` in the macro callsite context.

   Infers an implicit value of the expected type `pt` in the macro callsite context. Optional `pos` parameter provides a position that will be associated with the implicit search.

   If `silent` is false, `TypecheckException` will be thrown in case of an inference error. If `silent` is true, the typecheck is silent and will return `EmptyTree` if an error occurs. Such errors don't vanish and can be inspected by turning on -Xlog-implicits. Unlike in `typeCheck`, `silent` is true by default.

   Exceptions thrown
     [[scala.reflect.macros.TypecheckException]]

2. #### abstract def inferImplicitView(tree: Context.Tree, from: Context.Type, to: Context.Type, silent: Boolean = true, withMacrosDisabled: Boolean = false, pos: Context.Position = enclosingPosition): Context.Tree

   Infers an implicit view from the provided tree `tree` of the type `from` to the type `to` in the macro callsite context.

   Infers an implicit view from the provided tree `tree` of the type `from` to the type `to` in the macro callsite context. Optional `pos` parameter provides a position that will be associated with the implicit search.

   If `silent` is false, `TypecheckException` will be thrown in case of an inference error. If `silent` is true, the typecheck is silent and will return `EmptyTree` if an error occurs. Such errors don't vanish and can be inspected by turning on -Xlog-implicits. Unlike in `typeCheck`, `silent` is true by default.

   Exceptions thrown
     [[scala.reflect.macros.TypecheckException]]

3. #### abstract def openImplicits: List[(Context.Type, Context.Tree)]

   Types along with corresponding trees for which implicit arguments are currently searched.

   Types along with corresponding trees for which implicit arguments are currently searched. Can be useful to get information about an application with an implicit parameter that is materialized during current macro expansion.

   Unlike `enclosingImplicits`, this is a def, which means that it gets recalculated on every invocation, so it might change depending on what is going on during macro expansion.

4. #### abstract def openMacros: List[Context]

   Contexts that represent macros in-flight, including the current one.

   Contexts that represent macros in-flight, including the current one. Very much like a stack trace, but for macros only. Can be useful for interoperating with other macros and for imposing compiler-friendly limits on macro expansion.

   Is also priceless for emitting sane error messages for macros that are called by other macros on synthetic (i.e. position-less) trees. In that dire case navigate the `openMacros` stack, and it will most likely contain at least one macro with a position-ful macro application. See `enclosingPosition` for a default implementation of this logic.

   Unlike `enclosingMacros`, this is a def, which means that it gets recalculated on every invocation, so it might change depending on what is going on during macro expansion.

5. #### abstract def resetAllAttrs(tree: Context.Tree): Context.Tree

   Recursively resets symbols and types in a given tree.

   Recursively resets symbols and types in a given tree.

   Note that this does not revert the tree to its pre-typer shape. For more info, read up https://issues.scala-lang.org/browse/SI-5464.

6. #### abstract def resetLocalAttrs(tree: Context.Tree): Context.Tree

   Recursively resets locally defined symbols and types in a given tree.

   Recursively resets locally defined symbols and types in a given tree.

   Note that this does not revert the tree to its pre-typer shape. For more info, read up https://issues.scala-lang.org/browse/SI-5464.

7. #### abstract def typeCheck(tree: Context.Tree, pt: Context.Type = WildcardType, silent: Boolean = false, withImplicitViewsDisabled: Boolean = false, withMacrosDisabled: Boolean = false): Context.Tree

   Typechecks the provided tree against the expected type `pt` in the macro callsite context.

   Typechecks the provided tree against the expected type `pt` in the macro callsite context.

   If `silent` is false, `TypecheckException` will be thrown in case of a typecheck error. If `silent` is true, the typecheck is silent and will return `EmptyTree` if an error occurs. Such errors don't vanish and can be inspected by turning on -Ymacro-debug-verbose. Unlike in `inferImplicitValue` and `inferImplicitView`, `silent` is false by default.

   Typechecking can be steered with the following optional parameters: `withImplicitViewsDisabled` recursively prohibits implicit views (though, implicit vals will still be looked up and filled in), default value is false `withMacrosDisabled` recursively prohibits macro expansions and macro-based implicits, default value is false

   Exceptions thrown
     [[scala.reflect.macros.TypecheckException]]

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Typers to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (Typers, B)

   Implicit information
     This member is added by an implicit conversion from Typers to ArrowAssoc[Typers] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()
   Note

     not specified by SLS as a member of AnyRef

10. #### def ensuring(cond: (Typers) ⇒ Boolean, msg: ⇒ Any): Typers

    Implicit information
      This member is added by an implicit conversion from Typers to Ensuring[Typers] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: (Typers) ⇒ Boolean): Typers

    Implicit information
      This member is added by an implicit conversion from Typers to Ensuring[Typers] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean, msg: ⇒ Any): Typers

    Implicit information
      This member is added by an implicit conversion from Typers to Ensuring[Typers] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean): Typers

    Implicit information
      This member is added by an implicit conversion from Typers to Ensuring[Typers] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

17. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Typers to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

18. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

20. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

21. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

23. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

25. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

26. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

27. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

28. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

29. #### def →[B](y: B): (Typers, B)

    Implicit information
      This member is added by an implicit conversion from Typers to ArrowAssoc[Typers] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implict Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Typers to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (typers: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Typers to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (typers: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: Typers

   Implicit information
     This member is added by an implicit conversion from Typers to ArrowAssoc[Typers] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (typers: ArrowAssoc[Typers]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: Typers

   Implicit information
     This member is added by an implicit conversion from Typers to Ensuring[Typers] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (typers: Ensuring[Typers]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Typers to StringAdd

### Inherited by implicit conversion any2stringfmt from Typers to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from Typers to ArrowAssoc[Typers]

### Inherited by implicit conversion any2Ensuring from Typers to Ensuring[Typers]

### Ungrouped